function  [Zia, Zir] = MatrixInput(Xtr, Ytr, k, p)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Xtr is the training data                      %
% Ytr is the training label                     %
% k is the k nearest neighbor for intraclass    %
% Zia: The intraclass matrix based k neighbor   %
% Zir: The interclass matrix with all points    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin < 4,
   p = 1;
end;
a = unique(Ytr);
a = sort(a);
Zia = [];
Zir = [];
n = length(a);
for i = 1:n-1,
    j1 = find(Ytr == a(i));
    j2 = find(Ytr > a(i));
    X1 = Xtr(j1,:);
    X2 = Xtr(j2,:);
    Z1  = IntraKNN(X1, k, p);
    Zia = [Zia; Z1];
    [m1, n1] = size(X1);
    [m2, n1] = size(X2);
    T1 = repmat(X1, m2,1);
    T2 = repmat(X2, m1,1);
    Zir = [Zir; T1-T2];
end;

%Fially the class with largest label
j = find(Ytr == a(n));
X1 = Xtr(j,:);
Z1  = IntraKNN(X1, k, p);
Zia = [Zia; Z1];
    
 Zia = abs(Zia).^p;
 Zir = abs(Zir).^p;