function [Testerror, Ttable, Normscore, Testscore] = mdisttest(Xtr, Ytr,  Xte, Yte, w, k, p, choice)
% Xtr: Training data
% Xte: Test  data
% w is the weight (estimated parameter
% k is the k nearest neighbor
% Test error
% Test score
if nargin < 8,
    choice = 1;
end;

[m1, n1] = size(Xtr);
[m2, n2] = size(Xte);

if n1 ~= n2,
    error('Training and test data must have the same dimension');
end

  
a = unique(Ytr);
Testscore = zeros(m2, length(a)); 
for l =1:m2,
    for i = 1:length(a),
        j = find(Ytr == a(i));
        X1 = Xtr(j,:);
        [m, n] =size(X1);
        X2 =repmat(Xte(l,:),m, 1) - X1;
        score1 = abs(X2).^p*w;
        nbscore = sort(score1, 'ascend');
        if choice ==1,
           tscore = mean(nbscore(1:k));
        elseif choice == 2
           tscore = median(nbscore(1:k));
        elseif choice ==3,
             tscore = nbscore(1);
        elseif choice ==4,
            tscore =nbscore(k);
        else
            tscore = nbscore(1);
        end
        Testscore(l,i) = tscore; 
    end;
   
end;
Normscore = exp(-Testscore)./repmat(sum(exp(-Testscore), 2), 1, length(a));
[dummy, Yt] = max(Normscore, [], 2);
Ttable = crosstab(Yte, Yt);
Testerror = sum(Yt ~= Yte)/length(Yte);
end

